diff -uNr PDFlib-Lite-7.0.4.bak/bind/pdflib/java/Makefile PDFlib-Lite-7.0.4/bind/pdflib/java/Makefile
--- PDFlib-Lite-7.0.4.bak/bind/pdflib/java/Makefile	2009-03-20 11:07:47.000000000 +0100
+++ PDFlib-Lite-7.0.4/bind/pdflib/java/Makefile	2009-06-08 17:57:34.000000000 +0200
@@ -1,11 +1,11 @@
 # Makefile for PDFlib's Java binding
-# $Id: Makefile,v 1.55.2.16 2009/03/11 19:08:18 rjs Exp $
+# $Id: Makefile,v 1.55.2.18 2009/04/21 12:15:36 rjs Exp $
 
 top_builddir	= ../../..
 MYJAR   = pdflib.jar
-JAVAC   = javac -classpath $(MAYJAR):.
+JAVAC   = javac -classpath $(MYJAR):.
 COMPILE = $(JAVAC) $(JAVACFLAGS)
-JAVA    = $(LIBTOOL_EXE) $(JAVA) -classpath $(MYJAR)
+JAVA    = $(LIBTOOL_EXE) java -classpath $(MYJAR):.
 JAR     = jar
 
 include ../../../config/mkcommon.inc
@@ -108,10 +108,10 @@
 install:: $(LIBNAME) pdflib.jar
 	@-if test -f .libs/libpdf_java.jnilib; then		\
 	    $(LIBTOOL) --mode=install $(INSTALL_DATA)		\
-		.libs/libpdf_java.jnilib $(DESTDIR)$(LANG_LIBDIR);	\
+		.libs/libpdf_java.jnilib $(LANG_LIBDIR);	\
 	else							\
 	    $(LIBTOOL) --mode=install $(INSTALL_DATA)		\
-		$(LIBNAME) $(DESTDIR)$(LANG_LIBDIR);			\
+		$(LIBNAME) $(LANG_LIBDIR);			\
 	fi
 	@echo Copy pdflib.jar and javadoc to an appropriate directory,
 	@echo and include pdflib.jar in your CLASSPATH.
diff -uNr PDFlib-Lite-7.0.4.bak/bind/pdflib/java/PDFlibException.java PDFlib-Lite-7.0.4/bind/pdflib/java/PDFlibException.java
--- PDFlib-Lite-7.0.4.bak/bind/pdflib/java/PDFlibException.java	2009-03-18 15:10:03.000000000 +0100
+++ PDFlib-Lite-7.0.4/bind/pdflib/java/PDFlibException.java	2009-06-08 17:57:26.000000000 +0200
@@ -10,7 +10,7 @@
  |                                                                           |
  *---------------------------------------------------------------------------*/
 
-/* $Id: PDFlibException.java,v 1.41.2.43 2009/03/16 14:52:02 rjs Exp $
+/* $Id: PDFlibException.java,v 1.41.2.47 2009/06/08 15:36:38 rjs Exp $
  *
  * PDFlibException Java class
  */
@@ -21,7 +21,7 @@
 
     Exception handling for PDFlib.
     @author Rainer Schaaf
-    @version 7.0.4
+    @version 7.0.4p4
 */
 
 public class PDFlibException extends Exception {
diff -uNr PDFlib-Lite-7.0.4.bak/bind/pdflib/java/pdflib.java PDFlib-Lite-7.0.4/bind/pdflib/java/pdflib.java
--- PDFlib-Lite-7.0.4.bak/bind/pdflib/java/pdflib.java	2009-03-18 15:10:03.000000000 +0100
+++ PDFlib-Lite-7.0.4/bind/pdflib/java/pdflib.java	2009-06-08 17:57:26.000000000 +0200
@@ -10,7 +10,7 @@
  |                                                                           |
  *---------------------------------------------------------------------------*/
 
-/* $Id: pdflib.java,v 1.106.2.45 2009/03/16 14:52:02 rjs Exp $
+/* $Id: pdflib.java,v 1.106.2.49 2009/06/08 15:36:38 rjs Exp $
  *
  * PDFlib Java class
  */
@@ -33,7 +33,7 @@
     PDFlib distribution.
 
     @author Thomas Merz
-    @version 7.0.4
+    @version 7.0.4p4
 */
 
 public final class pdflib {
diff -uNr PDFlib-Lite-7.0.4.bak/bind/pdflib/perl/Makefile PDFlib-Lite-7.0.4/bind/pdflib/perl/Makefile
--- PDFlib-Lite-7.0.4.bak/bind/pdflib/perl/Makefile	2009-03-20 11:07:47.000000000 +0100
+++ PDFlib-Lite-7.0.4/bind/pdflib/perl/Makefile	2009-06-08 17:57:34.000000000 +0200
@@ -56,8 +56,8 @@
 
 install:: $(LIBNAME)
 	$(LIBTOOL) --mode=install \
-		$(INSTALL_DATA) $(LIBNAME) $(DESTDIR)$(LANG_LIBDIR)
-	$(INSTALL_DATA) pdflib_pl.pm $(DESTDIR)$(LANG_LIBDIR)
+		$(INSTALL_DATA) $(LIBNAME) $(LANG_LIBDIR)
+	$(INSTALL_DATA) pdflib_pl.pm $(LANG_LIBDIR)
 
 uninstall::
 	$(LIBTOOL) --mode=uninstall \
diff -uNr PDFlib-Lite-7.0.4.bak/bind/pdflib/php/ext/pdf/php430pdf.dsp PDFlib-Lite-7.0.4/bind/pdflib/php/ext/pdf/php430pdf.dsp
--- PDFlib-Lite-7.0.4.bak/bind/pdflib/php/ext/pdf/php430pdf.dsp	2009-03-18 15:10:03.000000000 +0100
+++ PDFlib-Lite-7.0.4/bind/pdflib/php/ext/pdf/php430pdf.dsp	2009-06-08 17:57:26.000000000 +0200
@@ -44,7 +44,7 @@
 # PROP Ignore_Export_Lib 0
 # PROP Target_Dir ""
 # ADD BASE CPP /nologo /MT /W3 /GX /O2 /I "..\.." /I "..\..\..\Zend" /I "..\..\..\TSRM" /D "WIN32" /D "NDEBUG" /D "_WINDOWS" /D "_MBCS" /D "_USRDLL" /D "COMPILE_DL_PDF" /D ZTS=1 /YX /FD /c
-# ADD CPP /nologo /MD /W3 /GX /O2 /I "..\.." /I "..\..\main" /I "..\..\Zend" /I "..\..\TSRM" /I "..\..\..\..\pdflib-7.0.4\libs\pdflib" /D ZEND_DEBUG=0 /D "WIN32" /D "NDEBUG" /D "_WINDOWS" /D "_MBCS" /D "_USRDLL" /D "PDF_EXPORTS" /D "COMPILE_DL_PDF" /D "ZEND_WIN32" /D "PHP_WIN32" /D HAVE_PDFLIB=1 /D ZTS=1 /YX /FD /c
+# ADD CPP /nologo /MD /W3 /GX /O2 /I "..\.." /I "..\..\main" /I "..\..\Zend" /I "..\..\TSRM" /I "..\..\..\..\pdflib-7.0.4p4\libs\pdflib" /D ZEND_DEBUG=0 /D "WIN32" /D "NDEBUG" /D "_WINDOWS" /D "_MBCS" /D "_USRDLL" /D "PDF_EXPORTS" /D "COMPILE_DL_PDF" /D "ZEND_WIN32" /D "PHP_WIN32" /D HAVE_PDFLIB=1 /D ZTS=1 /YX /FD /c
 # ADD BASE MTL /nologo /D "NDEBUG" /mktyplib203 /win32
 # ADD MTL /nologo /D "NDEBUG" /mktyplib203 /win32
 # ADD BASE RSC /l 0x406 /d "NDEBUG"
@@ -54,7 +54,7 @@
 # ADD BSC32 /nologo
 LINK32=link.exe
 # ADD BASE LINK32 kernel32.lib user32.lib gdi32.lib winspool.lib comdlg32.lib advapi32.lib shell32.lib ole32.lib oleaut32.lib uuid.lib odbc32.lib odbccp32.lib php4ts.lib /nologo /dll /machine:I386
-# ADD LINK32 php4ts.lib pdflib.lib kernel32.lib user32.lib gdi32.lib winspool.lib comdlg32.lib advapi32.lib shell32.lib ole32.lib oleaut32.lib uuid.lib odbc32.lib odbccp32.lib /nologo /dll /machine:I386 /out:"..\..\Release_TS/libpdf_php.dll" /libpath:"..\..\Release_TS" /libpath:"..\..\Release_TS_Inline" /libpath:"..\..\..\..\pdflib-7.0.4\libs\pdflib\Release_MD" /libpath:"..\..\..\..\pdflib-7.0.4\libs\pdflib\Release_mtDLL"
+# ADD LINK32 php4ts.lib pdflib.lib kernel32.lib user32.lib gdi32.lib winspool.lib comdlg32.lib advapi32.lib shell32.lib ole32.lib oleaut32.lib uuid.lib odbc32.lib odbccp32.lib /nologo /dll /machine:I386 /out:"..\..\Release_TS/libpdf_php.dll" /libpath:"..\..\Release_TS" /libpath:"..\..\Release_TS_Inline" /libpath:"..\..\..\..\pdflib-7.0.4p4\libs\pdflib\Release_MD" /libpath:"..\..\..\..\pdflib-7.0.4p4\libs\pdflib\Release_mtDLL"
 # SUBTRACT LINK32 /pdb:none
 
 !ELSEIF  "$(CFG)" == "php430pdf - Win32 Debug_TS"
@@ -72,7 +72,7 @@
 # PROP Ignore_Export_Lib 0
 # PROP Target_Dir ""
 # ADD BASE CPP /nologo /MT /W3 /GX /O2 /I "..\.." /I "..\..\Zend" /I "..\..\TSRM" /D "WIN32" /D "NDEBUG" /D "_WINDOWS" /D "_MBCS" /D "_USRDLL" /D "COMPILE_DL_PDF" /D ZTS=1 /YX /FD /c
-# ADD CPP /nologo /MDd /W3 /GX /ZI /Od /I "..\.." /I "..\..\main" /I "..\..\Zend" /I "..\..\TSRM" /I "..\..\..\..\pdflib-7.0.4\libs\pdflib" /D ZEND_DEBUG=1 /D "WIN32" /D "NDEBUG" /D "_WINDOWS" /D "_MBCS" /D "_USRDLL" /D "PDF_EXPORTS" /D "COMPILE_DL_PDF" /D ZTS=1 /D "ZEND_WIN32" /D "PHP_WIN32" /D HAVE_PDFLIB=1 /FR /YX /FD /c
+# ADD CPP /nologo /MDd /W3 /GX /ZI /Od /I "..\.." /I "..\..\main" /I "..\..\Zend" /I "..\..\TSRM" /I "..\..\..\..\pdflib-7.0.4p4\libs\pdflib" /D ZEND_DEBUG=1 /D "WIN32" /D "NDEBUG" /D "_WINDOWS" /D "_MBCS" /D "_USRDLL" /D "PDF_EXPORTS" /D "COMPILE_DL_PDF" /D ZTS=1 /D "ZEND_WIN32" /D "PHP_WIN32" /D HAVE_PDFLIB=1 /FR /YX /FD /c
 # ADD BASE MTL /nologo /D "NDEBUG" /mktyplib203 /win32
 # ADD MTL /nologo /D "NDEBUG" /mktyplib203 /win32
 # ADD BASE RSC /l 0x406 /d "NDEBUG"
@@ -82,7 +82,7 @@
 # ADD BSC32 /nologo
 LINK32=link.exe
 # ADD BASE LINK32 kernel32.lib user32.lib gdi32.lib winspool.lib comdlg32.lib advapi32.lib shell32.lib ole32.lib oleaut32.lib uuid.lib odbc32.lib odbccp32.lib php4ts_debug.lib /nologo /dll /machine:I386
-# ADD LINK32 php4ts_debug.lib pdflib.lib zlib.lib libpng.lib libtiff.lib kernel32.lib user32.lib gdi32.lib winspool.lib comdlg32.lib advapi32.lib shell32.lib ole32.lib oleaut32.lib uuid.lib odbc32.lib odbccp32.lib /nologo /dll /debug /machine:I386 /out:"..\..\Debug_TS/libpdf_php.dll" /libpath:"..\..\Debug_TS" /libpath:"..\..\..\..\pdflib-7.0.4\libs\pdflib\Release_MD" /libpath:"..\..\..\..\pdflib-7.0.4\libs\pdflib\Release_mtDLL"
+# ADD LINK32 php4ts_debug.lib pdflib.lib zlib.lib libpng.lib libtiff.lib kernel32.lib user32.lib gdi32.lib winspool.lib comdlg32.lib advapi32.lib shell32.lib ole32.lib oleaut32.lib uuid.lib odbc32.lib odbccp32.lib /nologo /dll /debug /machine:I386 /out:"..\..\Debug_TS/libpdf_php.dll" /libpath:"..\..\Debug_TS" /libpath:"..\..\..\..\pdflib-7.0.4p4\libs\pdflib\Release_MD" /libpath:"..\..\..\..\pdflib-7.0.4p4\libs\pdflib\Release_mtDLL"
 
 !ENDIF
 
diff -uNr PDFlib-Lite-7.0.4.bak/bind/pdflib/python/Makefile PDFlib-Lite-7.0.4/bind/pdflib/python/Makefile
--- PDFlib-Lite-7.0.4.bak/bind/pdflib/python/Makefile	2009-03-20 11:07:47.000000000 +0100
+++ PDFlib-Lite-7.0.4/bind/pdflib/python/Makefile	2009-06-08 17:57:34.000000000 +0200
@@ -57,10 +57,10 @@
 
 install:: $(LIBNAME)
 	@-if test -f libpdflib_py.dylib; then		\
-	    $(INSTALL_DATA) .libs/pdflib_py.so $(DESTDIR)$(LANG_LIBDIR);	\
+	    $(INSTALL_DATA) .libs/pdflib_py.so $(LANG_LIBDIR);	\
 	else							\
 	    $(LIBTOOL) --mode=install $(INSTALL_DATA) 		\
-		$(LIBNAME) $(DESTDIR)$(LANG_LIBDIR);			\
+		$(LIBNAME) $(LANG_LIBDIR);			\
 	fi
 
 uninstall::
diff -uNr PDFlib-Lite-7.0.4.bak/bind/pdflib/ruby/Makefile PDFlib-Lite-7.0.4/bind/pdflib/ruby/Makefile
--- PDFlib-Lite-7.0.4.bak/bind/pdflib/ruby/Makefile	2009-03-18 15:10:12.000000000 +0100
+++ PDFlib-Lite-7.0.4/bind/pdflib/ruby/Makefile	2009-06-08 17:57:34.000000000 +0200
@@ -1,9 +1,9 @@
 # Makefile for PDFlib's Ruby binding
-# $Id: Makefile,v 1.16.2.17 2008/02/28 09:19:24 rjs Exp $
+# $Id: Makefile,v 1.16.2.18 2009/04/03 08:09:08 rjs Exp $
 
 top_builddir	= ../../..
 
-include $(top_builddir)/config/mkcommon.inc
+include ../../../config/mkcommon.inc
 
 DEPLIBS		= $(PDFLIBLINK)
 LIBS		= $(DEPLIBS)
@@ -19,7 +19,7 @@
 OBJ		= pdflib_ruby$(LO)
 SRC		= pdflib_ruby.c
 
-include $(top_builddir)/config/mkbind.inc
+include ../../../config/mkbind.inc
 
 test:: $(LIBNAME)
 	@-if test -f .libs/PDFlib.dylib; then  	\
diff -uNr PDFlib-Lite-7.0.4.bak/bind/pdflib/tcl/Makefile PDFlib-Lite-7.0.4/bind/pdflib/tcl/Makefile
--- PDFlib-Lite-7.0.4.bak/bind/pdflib/tcl/Makefile	2009-03-20 11:07:47.000000000 +0100
+++ PDFlib-Lite-7.0.4/bind/pdflib/tcl/Makefile	2009-06-08 17:57:34.000000000 +0200
@@ -57,16 +57,16 @@
 	../../../progs/pdi/pdfcheck -i ../java/starter.ref -o -
 
 install:: $(LIBNAME)
-	if test ! -d $(DESTDIR)$(LANG_LIBDIR) ; then 	\
-	    mkdir -p $(DESTDIR)$(LANG_LIBDIR);		\
-	    chmod 755 $(DESTDIR)$(LANG_LIBDIR);		\
+	if test ! -d $(LANG_LIBDIR) ; then 	\
+	    mkdir -p $(LANG_LIBDIR);		\
+	    chmod 755 $(LANG_LIBDIR);		\
 	fi
-	$(INSTALL_DATA) pkgIndex.tcl $(DESTDIR)$(LANG_LIBDIR)
+	$(INSTALL_DATA) pkgIndex.tcl $(LANG_LIBDIR)
 	@-if test -f .libs/libpdflib_tcl.dylib; then			\
-	    $(INSTALL_DATA) .libs/pdflib_tcl.dylib $(DESTDIR)$(LANG_LIBDIR);	\
+	    $(INSTALL_DATA) .libs/pdflib_tcl.dylib $(LANG_LIBDIR);	\
 	else								\
 	    $(LIBTOOL) --mode=install $(INSTALL_DATA)			\
-		$(LIBNAME) $(DESTDIR)$(LANG_LIBDIR);				\
+		$(LIBNAME) $(LANG_LIBDIR);				\
 	fi
 
 uninstall::
diff -uNr PDFlib-Lite-7.0.4.bak/bind/pdflib/tcl/pdflib_tcl.c PDFlib-Lite-7.0.4/bind/pdflib/tcl/pdflib_tcl.c
--- PDFlib-Lite-7.0.4.bak/bind/pdflib/tcl/pdflib_tcl.c	2009-03-18 15:10:12.000000000 +0100
+++ PDFlib-Lite-7.0.4/bind/pdflib/tcl/pdflib_tcl.c	2009-06-08 17:57:34.000000000 +0200
@@ -10,7 +10,7 @@
  |                                                                           |
  *---------------------------------------------------------------------------*/
 
-/* $Id: pdflib_tcl.c,v 1.56.2.2 2008/08/27 12:37:59 rjs Exp $
+/* $Id: pdflib_tcl.c,v 1.56.2.3 2009/04/21 10:35:23 rjs Exp $
  *
  * in sync with pdflib.h 1.151.2.22
  *
@@ -867,6 +867,11 @@
 
 SWIGEXPORT(int,Pdflib_Init)(Tcl_Interp *interp)
 {
+    char short_version[6];
+
+    strncpy(short_version, PDFLIB_VERSIONSTRING, 5);
+    short_version[5] = 0;
+
     if (interp == 0)
 	return TCL_ERROR;
 
@@ -881,7 +886,7 @@
 #endif
 
     /* Tell Tcl which package we are going to define */
-    Tcl_PkgProvide(interp, "pdflib", PDFLIB_VERSIONSTRING);
+    Tcl_PkgProvide(interp, "pdflib", short_version);
 
     Tcl_CreateObjCommand(interp, "PDF_open_pdi",
                 (Tcl_ObjCmdProc*) _wrap_PDF_open_pdi,
diff -uNr PDFlib-Lite-7.0.4.bak/bind/pdflib/tcl/pkgIndex.tcl PDFlib-Lite-7.0.4/bind/pdflib/tcl/pkgIndex.tcl
--- PDFlib-Lite-7.0.4.bak/bind/pdflib/tcl/pkgIndex.tcl	2009-03-18 15:10:03.000000000 +0100
+++ PDFlib-Lite-7.0.4/bind/pdflib/tcl/pkgIndex.tcl	2009-06-08 17:57:26.000000000 +0200
@@ -8,4 +8,4 @@
 # script is sourced, the variable $dir must contain the
 # full path name of this file's directory.
 
-package ifneeded pdflib 7.0 [list load [file join $dir pdflib_tcl[info sharedlibextension]]]
+package ifneeded pdflib 7.0.4 [list load [file join $dir pdflib_tcl[info sharedlibextension]]]
diff -uNr PDFlib-Lite-7.0.4.bak/config/mkcommon.inc.win PDFlib-Lite-7.0.4/config/mkcommon.inc.win
--- PDFlib-Lite-7.0.4.bak/config/mkcommon.inc.win	2009-03-18 15:10:04.000000000 +0100
+++ PDFlib-Lite-7.0.4/config/mkcommon.inc.win	2009-06-08 17:57:26.000000000 +0200
@@ -1,5 +1,5 @@
 # Template to be included from every makefile that creates libs/progs
-# $Id: mkcommon.inc.win,v 1.6.2.21 2009/01/12 10:51:31 rjs Exp $
+# $Id: mkcommon.inc.win,v 1.6.2.23 2009/05/05 09:06:02 rjs Exp $
 # vim: syntax=make noexpandtab
 #
 # Windows version to be used with nmake only
@@ -31,6 +31,13 @@
 OO_SUFFIX =
 !ENDIF
 
+# detect English system needed for some ATS Runs
+!IF ( "$(PROGRAMFILES)" == "C:\Programme" )
+ENGLISH_WINDOWS_SYSTEM =
+!ELSE
+ENGLISH_WINDOWS_SYSTEM = /D ENGLISH_WINDOWS_SYSTEM
+!ENDIF
+
 # see which compiler we are using
 # this is not perfect, but till now we don't know a better method finding
 # out which compiler is used
@@ -215,9 +222,9 @@
 
 RUBYINCLUDE     =
 
-TCLINCLUDE      = /I "c:/programme/tcl/include"
+TCLINCLUDE      = /I "c:/programme/tcl8.5/include"
 TCLPACKAGEDIR   =
-TCLLIB          = /LIBPATH:"c:\programme\tcl\lib" tclstub84.lib
+TCLLIB          = /LIBPATH:"c:/programme/tcl8.5/lib" tclstub85.lib
 TCLBIN          = tclsh
 
 # Java
diff -uNr PDFlib-Lite-7.0.4.bak/configure.in PDFlib-Lite-7.0.4/configure.in
--- PDFlib-Lite-7.0.4.bak/configure.in	2009-03-18 15:10:04.000000000 +0100
+++ PDFlib-Lite-7.0.4/configure.in	2009-06-08 17:57:26.000000000 +0200
@@ -10,7 +10,7 @@
 dnl                                                                            |
 dnl --------------------------------------------------------------------------*/
 
-dnl $Id: configure.in,v 1.235.2.124 2009/03/16 14:51:47 rjs Exp $
+dnl $Id: configure.in,v 1.235.2.128 2009/06/08 15:36:29 rjs Exp $
 dnl
 dnl Process this file with autoconf to produce a configure script.
 dnl
@@ -23,7 +23,7 @@
 AC_INIT(libs/pdcore/pc_config.h)
 
 dnl do not change this (version.sh will do it for you :)
-VERSION="7.0.4"
+VERSION="7.0.4p4"
 PDFLIB_MAJOR=7
 PDFLIB_MINOR=0
 PDFLIB_REVISION=4
@@ -63,7 +63,7 @@
 
 # do not remove this second RCS Id as we want to have it in the generated
 # configure script
-# $Id: configure.in,v 1.235.2.124 2009/03/16 14:51:47 rjs Exp $
+# $Id: configure.in,v 1.235.2.128 2009/06/08 15:36:29 rjs Exp $
 # required for the pdflib-config script
 AC_SUBST(PDFLIB_LTCURRENT)
 AC_SUBST(PDFLIB_LTREVISION)
diff -uNr PDFlib-Lite-7.0.4.bak/libs/pdcore/pc_config.h PDFlib-Lite-7.0.4/libs/pdcore/pc_config.h
--- PDFlib-Lite-7.0.4.bak/libs/pdcore/pc_config.h	2009-03-18 15:10:05.000000000 +0100
+++ PDFlib-Lite-7.0.4/libs/pdcore/pc_config.h	2009-06-08 17:57:27.000000000 +0200
@@ -10,7 +10,7 @@
  |                                                                           |
  *---------------------------------------------------------------------------*/
 
-/* $Id: pc_config.h,v 1.56.2.29 2008/03/12 16:47:29 rjs Exp $
+/* $Id: pc_config.h,v 1.56.2.31 2009/05/04 18:34:43 rjs Exp $
  *
  * PDFlib portability and configuration definitions
  *
@@ -305,6 +305,9 @@
 # ifndef _LARGE_FILE_API
    #error You need to compile this module with DEFINE(_LARGE_FILE_API)
 # endif
+
+#define _LARGEFILE_SOURCE
+
 # ifndef __TERASPACE__
    #error You need to compile this module with TERASPACE(*YES *TSIFC)
 STGMDL(*TERASPACE)
diff -uNr PDFlib-Lite-7.0.4.bak/libs/pdcore/pc_contain.c PDFlib-Lite-7.0.4/libs/pdcore/pc_contain.c
--- PDFlib-Lite-7.0.4.bak/libs/pdcore/pc_contain.c	2009-03-18 15:10:05.000000000 +0100
+++ PDFlib-Lite-7.0.4/libs/pdcore/pc_contain.c	2009-06-08 17:57:27.000000000 +0200
@@ -10,7 +10,7 @@
  |                                                                           |
  *---------------------------------------------------------------------------*/
 
-/* $Id: pc_contain.c,v 1.19 2006/08/17 16:05:07 york Exp $
+/* $Id: pc_contain.c,v 1.19.2.8 2009/05/29 10:06:59 york Exp $
  *
  * PDFlib generic container classes
  *
@@ -221,7 +221,186 @@
 
 #endif	/* COMMENT */
 
-/***************************** vector class *****************************/
+
+/*************************** bit vector class ***************************/
+
+struct pdc_bvtr_s
+{
+    pdc_core *	pdc;
+
+    char **	ctab;		/* chunk table				*/
+    int		ctab_size;	/* current # of slots			*/
+    int		ctab_incr;
+    int		chunk_size;	/* # of bytes per chunk			*/
+    int		size;		/* current # of bytes total		*/
+    char	init_char;	/* 0x00 or 0xFF				*/
+};
+
+
+static const pdc_bvtr_parms bvtr_dflt_parms =
+{
+    0,				/* initial number of bits		*/
+    pdc_false,			/* initial bit value			*/
+    1000,			/* number of bytes per chunk		*/
+    10				/* chunk table increment		*/
+};
+
+
+void pdc_bvtr_dflt_parms(pdc_bvtr_parms *vp)
+{
+    *vp = bvtr_dflt_parms;
+}
+
+
+pdc_bvtr *pdc_bvtr_new(pdc_core *pdc, const pdc_bvtr_parms *parms)
+{
+    static const char fn[] = "pdc_bvtr_new";
+
+    pdc_bvtr *v = (pdc_bvtr *) pdc_malloc(pdc, sizeof (pdc_bvtr), fn);
+
+    if (!parms)
+	parms = &bvtr_dflt_parms;
+
+    v->pdc = pdc;
+
+    v->ctab = (char **) 0;
+    v->ctab_size = 0;
+    v->ctab_incr = parms->ctab_incr;
+    v->chunk_size = parms->chunk_size;
+    v->size = 0;
+    v->init_char = parms->init_value ? 0xFF : 0x00;
+
+    if (parms->init_n_bits != 0)
+    {
+	PDC_TRY (pdc)
+	{
+	    pdc_bvtr_resize(v, parms->init_n_bits);
+	}
+	PDC_CATCH (pdc)
+	{
+	    pdc_bvtr_delete(v);
+	    PDC_RETHROW(pdc);
+	}
+    }
+
+    return v;
+} /* pdc_bvtr_new */
+
+
+void pdc_bvtr_delete(pdc_bvtr *v)
+{
+    int i;
+
+    for (i = 0; i < v->ctab_size && v->ctab[i]; ++i)
+    {
+	pdc_free(v->pdc, v->ctab[i]);
+    }
+
+    if (v->ctab)
+	pdc_free(v->pdc, v->ctab);
+
+    pdc_free(v->pdc, v);
+} /* pdc_bvtr_delete */
+
+
+void
+pdc_bvtr_resize(pdc_bvtr *v, int n_bits)
+{
+    static const char fn[] = "pdc_bvtr_resize";
+
+    int cs = v->chunk_size;
+    int new_size = (n_bits + 7) / 8;
+    int new_ctsize = (new_size + cs - 1) / cs;	/* TODO: ctab_incr? */
+    int i;
+
+    PDC_ASSERT(v->pdc, 0 <= n_bits);
+
+    if (new_size < v->size)
+    {
+	if (new_ctsize < v->ctab_size)
+	{
+	    for (i = new_ctsize; i < v->ctab_size; ++i)
+	    {
+		pdc_free(v->pdc, v->ctab[i]);
+	    }
+	}
+
+	v->ctab_size = new_ctsize;
+	v->size = new_ctsize * cs;
+    }
+    else if (new_size > v->size)
+    {
+	v->ctab = (char **) pdc_realloc(v->pdc, v->ctab,
+				(size_t) (new_ctsize * sizeof (char *)), fn);
+
+	for (i = v->size / cs; i < new_ctsize; ++i)
+	{
+	    int k;
+
+	    v->ctab[i] = (char *) pdc_malloc(v->pdc, (size_t) cs, fn);
+
+	    for (k = 0; k < cs; ++k)
+	    {
+		v->ctab[i][k] = v->init_char;
+	    }
+	}
+
+	v->ctab_size = new_ctsize;
+	v->size = new_ctsize * cs;
+    }
+} /* pdc_vtr_resize */
+
+
+pdc_bool
+pdc_bvtr_getbit(const pdc_bvtr *v, int n)
+{
+    static const char fn[] = "pdc_bvtr_getbit";
+
+    int cs = v->chunk_size;
+    int idx = n / 8;
+    int bit = 1 << (n % 8);
+
+    if (idx < 0 || v->size <= idx)
+	pdc_error(v->pdc, PDC_E_INT_ARRIDX,
+	    pdc_errprintf(v->pdc, "%d", n), fn, 0, 0);
+
+    return (v->ctab[idx / cs][idx % cs] & bit) != 0;
+} /* pdc_bvtr_getbit */
+
+
+void pdc_bvtr_setbit(const pdc_bvtr *v, int n)
+{
+    static const char fn[] = "pdc_bvtr_setbit";
+
+    int cs = v->chunk_size;
+    int idx = n / 8;
+    int bit = 1 << (n % 8);
+
+    if (idx < 0 || v->size <= idx)
+	pdc_error(v->pdc, PDC_E_INT_ARRIDX,
+	    pdc_errprintf(v->pdc, "%d", n), fn, 0, 0);
+
+    v->ctab[idx / cs][idx % cs] |= bit;
+} /* pdc_bvtr_setbit */
+
+
+void pdc_bvtr_clrbit(const pdc_bvtr *v, int n)
+{
+    static const char fn[] = "pdc_bvtr_clrbit";
+
+    int cs = v->chunk_size;
+    int idx = n / 8;
+    int bit = 1 << (n % 8);
+
+    if (idx < 0 || v->size <= idx)
+	pdc_error(v->pdc, PDC_E_INT_ARRIDX,
+	    pdc_errprintf(v->pdc, "%d", n), fn, 0, 0);
+
+    v->ctab[idx / cs][idx % cs] &= ~bit;
+} /* pdc_bvtr_clrbit */
+
+
+/*********************** stack type vector class ************************/
 
 struct pdc_vtr_s
 {
@@ -242,7 +421,7 @@
 {
     0,				/* init_size				*/
     100,			/* chunk_size				*/
-    10				/* ctab_incr				*/
+    10,				/* ctab_incr				*/
 };
 
 void
@@ -413,7 +592,6 @@
     if (idx < 0 || v->size <= idx)
 	pdc_error(v->pdc, PDC_E_INT_ARRIDX,
 	    pdc_errprintf(v->pdc, "%d", idx), fn, 0, 0);
-	    /* TODO: "%u" */
 
     return (void *) (&v->ctab[idx / cs][(idx % cs) * v->ced.size]);
 } /* pdc__vtr_at */
@@ -430,7 +608,6 @@
     if (idx < 0 || v->size <= idx)
 	pdc_error(v->pdc, PDC_E_INT_ARRIDX,
 	    pdc_errprintf(v->pdc, "%d", idx), fn, 0, 0);
-	    /* TODO: "%u" */
 
     return (const void *) (&v->ctab[idx / cs][(idx % cs) * v->ced.size]);
 } /* pdc__vtr_at_c */
@@ -516,3 +693,315 @@
 	    &v->ctab[v->size / cs][(v->size % cs) * v->ced.size]);
     }
 } /* pdc_vtr_pop */
+
+
+/************************ heap type vector class ************************/
+
+typedef struct pdc_link_s	pdc_link;
+typedef struct pdc_chunk_s	pdc_chunk;
+
+struct pdc_link_s		/* for doubly linked free items list	*/
+{
+    int		idx;
+    pdc_link *	prev;		/* previous item in free list		*/
+    pdc_link *	next;		/* next item in free list		*/
+};
+
+
+struct pdc_chunk_s
+{
+    char *	data;		/* the items in this chunk		*/
+    int		n_items;	/* number of used items in this chunk	*/
+
+    pdc_chunk *	next;		/* next chunk in free list		*/
+};
+
+
+struct pdc_hvtr_s
+{
+    pdc_core *	pdc;
+
+    pdc_ced	ced;		/* container entry descriptor		*/
+    void *	context;	/* client context			*/
+
+    pdc_chunk *	ctab;		/* chunk table				*/
+    int		ctab_size;	/* current # of slots			*/
+    int		ctab_incr;
+    int		chunk_size;	/* # of items per chunk			*/
+    int		size;		/* current # of items total		*/
+
+    pdc_link *	free_items;	/* first item in free items list	*/
+    pdc_link	end_items;	/* sentinel				*/
+    pdc_chunk *	free_chunks;	/* first chunk in free chunks list	*/
+    pdc_chunk	end_chunks;	/* sentinel				*/
+
+    pdc_bvtr *	free_mask;	/* bit mask of free items		*/
+};
+
+
+static const pdc_hvtr_parms hvtr_dflt_parms =
+{
+    100,			/* chunk_size				*/
+    10,				/* ctab_incr				*/
+};
+
+void
+pdc_hvtr_dflt_parms(pdc_hvtr_parms *vp)
+{
+    *vp = hvtr_dflt_parms;
+}
+
+
+pdc_hvtr *
+pdc_hvtr_new(
+    pdc_core *pdc,
+    const pdc_ced *ced,
+    void *context,
+    const pdc_hvtr_parms *parms)
+{
+    static const char fn[] = "pdc_hvtr_new";
+
+    pdc_hvtr *v = (pdc_hvtr *) pdc_malloc(pdc, sizeof (pdc_hvtr), fn);
+
+    if (!parms)
+	parms = &hvtr_dflt_parms;
+
+    v->pdc = pdc;
+    v->ced = *ced;
+    v->context = context ? context : pdc;
+
+    if (v->ced.size < sizeof (pdc_link))
+    {
+	v->ced.size = sizeof (pdc_link);
+    }
+
+    v->ctab = (pdc_chunk *) 0;
+    v->ctab_size = 0;
+    v->ctab_incr = parms->ctab_incr;
+    v->chunk_size = parms->chunk_size;
+    v->size = 0;
+
+    v->free_items = &v->end_items;
+    v->end_items.next = v->end_items.prev = &v->end_items;
+    v->free_chunks = &v->end_chunks;
+    v->free_mask = 0;
+
+    PDC_TRY (pdc)
+    {
+	pdc_bvtr_parms bvp;
+
+	pdc_bvtr_dflt_parms(&bvp);
+	bvp.init_value = pdc_true;
+	v->free_mask = pdc_bvtr_new(pdc, &bvp);
+    }
+    PDC_CATCH (pdc)
+    {
+	pdc_hvtr_delete(v);
+	PDC_RETHROW(pdc);
+    }
+
+    return v;
+} /* pdc_hvtr_new */
+
+
+void
+pdc_hvtr_delete(pdc_hvtr *v)
+{
+    int cs = v->chunk_size;
+    int i;
+
+    if (v->size != 0 && v->ced.release)
+    {
+	for (i = 0; i < v->size; ++i)
+	{
+	    if (!pdc_bvtr_getbit(v->free_mask, i))
+	    {
+		v->ced.release(v->context, (void *)
+		    &v->ctab[i / cs].data[(i % cs) * v->ced.size]);
+	    }
+	}
+    }
+
+    if (v->ctab)
+    {
+	for (i = 0; i < v->ctab_size && v->ctab[i].data != (char *) 0; ++i)
+	{
+	    pdc_free(v->pdc, v->ctab[i].data);
+	}
+
+	pdc_free(v->pdc, v->ctab);
+    }
+
+    if (v->free_mask)
+    {
+	pdc_bvtr_delete(v->free_mask);
+    }
+
+    pdc_free(v->pdc, v);
+} /* pdc_hvtr_delete */
+
+
+void
+pdc_hvtr_release_item(pdc_hvtr *v, int idx)
+{
+    static const char fn[] = "pdc_hvtr_release_item";
+
+    const int	cs = v->chunk_size;
+    pdc_chunk *	chunk = &v->ctab[idx / cs];
+    void *	item;
+    pdc_link *	link;
+
+    if (idx < 0 || v->size <= idx || pdc_bvtr_getbit(v->free_mask, idx))
+    {
+	pdc_error(v->pdc, PDC_E_INT_ARRIDX,
+	    pdc_errprintf(v->pdc, "%d", idx), fn, 0, 0);
+    }
+
+    item = &chunk->data[(idx % cs) * v->ced.size];
+
+    if (v->ced.release)
+    {
+	v->ced.release(v->context, item);
+    }
+
+    pdc_bvtr_setbit(v->free_mask, idx);
+
+    link = (pdc_link *) item;
+    link->idx = idx;
+    link->next = v->free_items;
+    link->prev = &v->end_items;
+    link->next->prev = link->prev->next = link;
+    v->free_items = link;
+
+    if (--chunk->n_items == 0)
+    {
+	for (idx = 0; idx < cs; ++idx)
+	{
+	    link = (pdc_link *) &chunk->data[idx * v->ced.size];
+
+	    link->prev->next = link->next;
+	    link->next->prev = link->prev;
+	}
+
+	pdc_free(v->pdc, chunk->data);
+	chunk->data = 0;
+	chunk->next = v->free_chunks;
+	v->free_chunks = chunk;
+    }
+} /* pdc_hvtr_release_item */
+
+
+int
+pdc_hvtr_reclaim_item(pdc_hvtr *v)
+{
+    static const char fn[] = "pdc_hvtr_reclaim_item";
+
+    pdc_link *	new_item;
+    int		idx;
+
+    if (v->free_items != &v->end_items)
+    {
+	new_item = v->free_items;
+	new_item->prev->next = new_item->next;
+	new_item->next->prev = new_item->prev;
+	v->free_items = new_item->next;
+    }
+    else
+    {
+	/* install new chunk.
+	*/
+	const int	cs = v->chunk_size;
+	const int	es = v->ced.size;
+	pdc_chunk *	new_chunk;
+	pdc_link *	link;
+	int		base;
+
+	if (v->free_chunks != &v->end_chunks)
+	{
+	    new_chunk = v->free_chunks;
+	    v->free_chunks = new_chunk->next;
+	}
+	else
+	{
+	    int new_size = v->ctab_size + v->ctab_incr;
+
+	    v->ctab = (pdc_chunk *) pdc_realloc(v->pdc, v->ctab,
+				(size_t) (new_size * sizeof (pdc_chunk)), fn);
+
+	    for (idx = v->ctab_size; idx < new_size; ++idx)
+	    {
+		v->ctab[idx].data = (char *) 0;
+		v->ctab[idx].n_items = 0;
+		v->ctab[idx].next = &v->ctab[idx + 1];
+	    }
+
+	    v->ctab[new_size - 1].next = &v->end_chunks;
+	    v->free_chunks = &v->ctab[v->ctab_size + 1];
+	    new_chunk = &v->ctab[v->ctab_size];
+	    v->ctab_size = new_size;
+	    v->size += cs * v->ctab_incr;
+	    pdc_bvtr_resize(v->free_mask, v->size);
+	}
+
+	new_chunk->data = pdc_malloc(v->pdc, cs * es, fn);
+	base = cs * (new_chunk - &v->ctab[0]);
+
+	for (idx = 1; idx < cs; ++idx)
+	{
+	    link = (pdc_link *) &new_chunk->data[idx * es];
+
+	    link->idx = base + idx;
+	    link->prev = (pdc_link *) &new_chunk->data[(idx - 1) * es];
+	    link->next = (pdc_link *) &new_chunk->data[(idx + 1) * es];
+	}
+
+	/* end of new chain:
+	*/
+	link = (pdc_link *) &new_chunk->data[(cs - 1) * es];
+	link->next = v->free_items;
+	link->next->prev = link;
+
+	/* start of new chain:
+	*/
+	link = (pdc_link *) &new_chunk->data[1 * es];
+	link->prev = &v->end_items;
+	v->free_items = v->end_items.next = link;
+
+	new_item = (pdc_link *) &new_chunk->data[0];
+	new_item->idx = base;
+    }
+
+    idx = new_item->idx;
+    pdc_bvtr_clrbit(v->free_mask, idx);
+
+    if (v->ced.reclaim)
+    {
+	v->ced.reclaim((void *) new_item);
+    }
+
+    return idx;
+} /* pdc_hvtr_reclaim_item */
+
+
+pdc_bool
+pdc_hvtr_check_idx(const pdc_hvtr *v, int idx)
+{
+    return 0 <= idx && idx < v->size && !pdc_bvtr_getbit(v->free_mask, idx);
+} /* pdc__hvtr_at */
+
+
+void *
+pdc__hvtr_at(const pdc_hvtr *v, int idx)
+{
+    static const char fn[] = "pdc__hvtr_at";
+
+    int cs = v->chunk_size;
+
+    if (idx < 0 || v->size <= idx || pdc_bvtr_getbit(v->free_mask, idx))
+    {
+	pdc_error(v->pdc, PDC_E_INT_ARRIDX,
+	    pdc_errprintf(v->pdc, "%d", idx), fn, 0, 0);
+    }
+
+    return (void *) &v->ctab[idx / cs].data[(idx % cs) * v->ced.size];
+} /* pdc__hvtr_at */
diff -uNr PDFlib-Lite-7.0.4.bak/libs/pdcore/pc_contain.h PDFlib-Lite-7.0.4/libs/pdcore/pc_contain.h
--- PDFlib-Lite-7.0.4.bak/libs/pdcore/pc_contain.h	2009-03-18 15:10:05.000000000 +0100
+++ PDFlib-Lite-7.0.4/libs/pdcore/pc_contain.h	2009-06-08 17:57:27.000000000 +0200
@@ -10,7 +10,7 @@
  |                                                                           |
  *---------------------------------------------------------------------------*/
 
-/* $Id: pc_contain.h,v 1.11 2006/06/14 12:31:04 york Exp $
+/* $Id: pc_contain.h,v 1.11.2.3 2009/05/28 12:59:03 york Exp $
  *
  * PDFlib generic container classes
  *
@@ -47,7 +47,31 @@
 void		pdc_avl_for_each(const pdc_avl *t, pdc_for_each_cb cb);
 
 
-/***************************** vector class *****************************/
+/*************************** bit vector class ****************************/
+
+typedef struct	pdc_bvtr_s pdc_bvtr;
+
+typedef struct
+{
+    int		init_n_bits;	/* initial number of bits		*/
+    pdc_bool	init_value;	/* initial bit value			*/
+    int		chunk_size;	/* number of bits per chunk		*/
+    int		ctab_incr;	/* chunk table increment		*/
+} pdc_bvtr_parms;
+
+void		pdc_bvtr_dflt_parms(pdc_bvtr_parms *vp);
+
+pdc_bvtr *	pdc_bvtr_new(pdc_core *pdc, const pdc_bvtr_parms *parms);
+void		pdc_bvtr_delete(pdc_bvtr *v);
+
+void		pdc_bvtr_resize(pdc_bvtr *v, int n_bits);
+
+pdc_bool	pdc_bvtr_getbit(const pdc_bvtr *v, int n);
+void		pdc_bvtr_setbit(const pdc_bvtr *v, int n);
+void		pdc_bvtr_clrbit(const pdc_bvtr *v, int n);
+
+
+/************************ stack type vector class ************************/
 
 typedef struct	pdc_vtr_s pdc_vtr;
 
@@ -64,17 +88,11 @@
 		    const pdc_vtr_parms *parms);
 
 void		pdc_vtr_delete(pdc_vtr *v);
+
 int		pdc_vtr_size(const pdc_vtr *v);
 void		pdc_vtr_resize(pdc_vtr *v, int size);
 void		pdc_vtr_pop(pdc_vtr *v);
 
-/* don't use the pdc__vtr_xxx() functions directly.
-** use the respective pdc_vtr_xxx() macros below.
-*/
-void *		pdc__vtr_at(const pdc_vtr *v, int idx);
-void *		pdc__vtr_top(const pdc_vtr *v);
-void *		pdc__vtr_push(pdc_vtr *v);
-
 
 /* <type>	pdc_vtr_at(const pdc_vtr *v, int idx, <type>);
 **
@@ -107,4 +125,49 @@
 #define		pdc_vtr_incr(v, type)				\
 		((type *) pdc__vtr_push(v))
 
+
+/* don't use the pdc__vtr_xxx() functions directly.
+** use the respective pdc_vtr_xxx() macros above.
+*/
+void *		pdc__vtr_at(const pdc_vtr *v, int idx);
+void *		pdc__vtr_top(const pdc_vtr *v);
+void *		pdc__vtr_push(pdc_vtr *v);
+
+
+
+/************************ heap type vector class ************************/
+
+typedef struct	pdc_hvtr_s pdc_hvtr;
+
+typedef struct
+{
+    int		chunk_size;
+    int		ctab_incr;
+} pdc_hvtr_parms;
+
+void		pdc_hvtr_dflt_parms(pdc_hvtr_parms *vp);
+
+pdc_hvtr *	pdc_hvtr_new(pdc_core *pdc, const pdc_ced *ced, void *context,
+		    const pdc_hvtr_parms *parms);
+
+void		pdc_hvtr_delete(pdc_hvtr *v);
+
+void		pdc_hvtr_release_item(pdc_hvtr *v, int idx);
+int		pdc_hvtr_reclaim_item(pdc_hvtr *v);
+pdc_bool	pdc_hvtr_check_idx(const pdc_hvtr *v, int idx);
+
+
+/* <type>	pdc_hvtr_at(const pdc_hvtr *v, int idx, <type>);
+**
+**		(<type>) v[idx]
+*/
+#define		pdc_hvtr_at(v, idx, type)			\
+		(*((type *) pdc__hvtr_at(v, idx)))
+
+
+/* don't use the pdc__hvtr_xxx() functions directly.
+** use the respective pdc_hvtr_xxx() macros above.
+*/
+void *		pdc__hvtr_at(const pdc_hvtr *v, int idx);
+
 #endif	/* PC_CONTAIN_H */
